Package com.smartgwt.client.types

# Enum ElementWaitStyle

java.lang.Object
java.lang.Enum<ElementWaitStyle>
com.smartgwt.client.types.ElementWaitStyle

All Implemented Interfaces:
  `ValueEnum`, `Serializable`, `Comparable<ElementWaitStyle>`, `Constable`

public enum ElementWaitStyle extends Enum<ElementWaitStyle> implements ValueEnum
How should `AutoTest.waitForElement()` determine that the application is ready to retrieve the element?

Note: In most cases `"system"` is the appropriate setting. This will wait for standard Smart GWT-initiated asychronous actions to complete, including timer-instantiated actions such as `delayed redraws` or actions configured through the Timer class, and oustanding `RPC Requests`. If the locator cannot be resolved to a clickable element after system quiescence, this usually implies that it will not ever resolve, and there's no need to wait for the timeout to complete and slow down your test suite.

The only time you'd want to use `"element"` would be if your application relies on some asynchronous event that isn't tracked by the Smart GWT system. Examples might include waiting for asynchronous actions instantiated by a third-party tool on the page, or waiting for a server notification to come in through the `RealtimeMessaging` system.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ELEMENT`
  wait until `AutoTest.getElement()` resolves to an element, and the element is `clickable`.
  `SYSTEM`
  use `AutoTest.waitForSystemDone()` to wait for actions to complete, then return the result of `AutoTest.getElement()`, even if this method doesn't resolve to an element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getValue()`
  `static ElementWaitStyle`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static ElementWaitStyle[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SYSTEM

    public static final ElementWaitStyle SYSTEM
    use `AutoTest.waitForSystemDone()` to wait for actions to complete, then return the result of `AutoTest.getElement()`, even if this method doesn't resolve to an element.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "system".

  - ### ELEMENT

    public static final ElementWaitStyle ELEMENT
    wait until `AutoTest.getElement()` resolves to an element, and the element is `clickable`.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "element".

- ## Method Details

  - ### values

    public static ElementWaitStyle[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static ElementWaitStyle valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getValue

    public String getValue()
    Specified by:
      `getValue` in interface `ValueEnum`